%{
/* ------------------------------------------------------------------- */
/* ------------------------------------------------------------------- */
/*
	<MyJavaLexer.l>
*/
/* ------------------------------------------------------------------- */
/* ------------------------------------------------------------------- */

#include	<stdio.h>
#include	"MyJavaParser.tab.h"
#include        "MyJavaPrincipal.h"


#define		MyECHO	ECHO;



/* ------------------------------------------------------------------- */
/* ------------------------------------------------------------------- */
%}

PREM		[a-zA-Z]
DEUX		[a-zA-Z0-9]
VARIABLE        {PREM}{DEUX}*

NB_ENT		[0-9]+
NB_REEL         [+-]?NB_ENT("."NB_ENT)? 

%%

"//".*			{ MyECHO; }
[ \t\r]+		{ MyECHO; }

{VARIABLE} 		{ MyECHO; return(verif()); }

{NB_ENT}		{ MyECHO; return(ENTIER); }

{NB_REEL}               { MyECHO;return(REEL); }

"*="			{ MyECHO; return(MULTEQ); }
"/="			{ MyECHO; return(DIVEQ); }
"+="			{ MyECHO; return(PLUSEQ); }
"-="			{ MyECHO; return(MINUSEQ); }

"="			{ MyECHO; return(EQ); }
"*"			{ MyECHO; return(MULT); }
"/"			{ MyECHO; return(DIV); }
"+"			{ MyECHO; return(PLUS); }
"-"			{ MyECHO; return(MINUS); }

"<"			{ MyECHO; return(LT); }
">"			{ MyECHO; return(GT); }
"=="			{ MyECHO; return(EQEQ) ;}
"<="			{ MyECHO; return(LE) ;}
">="			{ MyECHO; return(GE) ;}

.			{ MyECHO; return(yytext[0]); }
\n			{ MyECHO; }

%%
