%{
/* ----------------------------------------------------------------- */
/*
	<MyJavaParser.y>
*/
/* ----------------------------------------------------------------- */

#include	<stdio.h>

%}

%token		IMPORT CLASS INTERFACE	EXTENDS	IMPLEMENTS 

%token		ABSTRACT FINAL PUBLIC PRIVATE PROTECTED STATIC

%token		TYPE	VARIABLE  REEL	ENTIER CONST

%token		IF ELSE
%token		WHILE DO FOR
%token		TRY CATCH FINALLY THROWS THROW
%token          RETURN

%token		BYTE CHAR INT FLOAT DOUBLE
%token		UNSIGNED

%token		NEW INSTANCEOF

%left		OROR
%left		ANDAND
%left		OR
%left		AND
%left		XOR
%left		NOT

%left		OREQ ANDEQ XOREQ

%left		UNARYMINUS
%left		PERCT
%left		PLUS MINUS PLUSEQ MINUSEQ
%left		MULT DIV MULTEQ DIVEQ

%left		EQ
%left		EQEQ NOTEQ
%left		LT GT LE GE

%nonassoc	PLUSPLUS MINUSMINUS
	
%start		fichier

%%

/*
	Exemples de constantes: 1234 et 1234.5678
	Il faudrait un signe et un exposant facultatifs...
*/

CONSTANTE	:	ENTIER
		|	ENTIER '.' ENTIER
		;

/*
  Definition canonique d'une variable plus ou moins indicee:
*/
VARIABLEpmi	:	VARIABLE
                |       VARIABLE '[' formuleAri']'
                |       VARIABLE '['formuleAri']' '['formuleAri']'
                |       VARIABLE '['formuleAri']' '['formuleAri']' '['formuleAri']'
		;

/* Definition canonique d'une formule logique  */
formuleLog	:	VARIABLEpmi
		|	CONSTANTE
		|	'(' formuleLog ')'
		|	formuleLog	OR	formuleLog
		|	formuleLog	AND	formuleLog
		|	formuleLog	XOR	formuleLog
		|	NOT	formuleLog
                |       formuleAri      EQEQ    formuleAri 
                |       formuleAri      NOTEQ   formuleAri 
                |       formuleAri      GT      formuleAri 
                |       formuleAri      LT      formuleAri 
                |       formuleAri      GE      formuleAri 
                |       formuleAri      LE      formuleAri    
		;

/* Definition canonique d'une formule arithmetique  */
formuleAri   :       VARIABLEpmi 
             |       CONSTANTE 
             |       '(' formuleAri ')' 
             |       formuleAri MULT formuleAri 
             |       formuleAri DIV formuleAri 
             |       formuleAri PLUS formuleAri 
             |       formuleAri MINUS formuleAri 
             |       UNARYMINUS formuleAri 
             ; 


/* ---------------------------------------------------------------- 
	Mots du developpeur
 ---------------------------------------------------------------- */

mot		:	VARIABLE
		;

nom		:	VARIABLE
		;

type		:	TYPE
		;

exc		:	VARIABLE
		;


/*   Definition d'indexation  */
ev_indices	:
		|	'[' ']'
		
		|	'[' ']' '[' ']'	
		
		|	'[' ']' '[' ']' '[' ']'	
		
		;

/* une solution sera un mot de 32 bits, remis a zero par le nom du membre */

ev_l_attribute	:
		|	l_attribute
		;
		
l_attribute	:	attribute
		|	l_attribute attribute
		;

attribute	:	PRIVATE
		|	PROTECTED
		|	PUBLIC
		|	ABSTRACT
		|	FINAL
		|	STATIC
		;

/* ---------------------------------------------------------------- 
debut important
---------------------------------------------------------------- */

fichier	        :	ev_l_import l_class
		;

ev_l_import	:
		|	l_import
		;

l_import	:	import
		|	l_import import
		;

import	:	IMPORT	importedName ';'
		;

importedName	:	mot
		|	importedName '.' MULT
		|	importedName '.' mot
		;

/* -------------------------------------------------------------------- */

l_class	        :	class
		|	l_class class
		;

class		:	ev_l_attribute CLASS
			nom ev_extends 
			'{' ev_l_membre '}'
		;

ev_extends	:
		|	EXTENDS VARIABLE
		;

ev_l_membre	:
		|	l_membre
		;

l_membre	:	membre
		|	l_membre membre
		;

membre		:	ev_l_attribute membre2
		;
		
membre2	        :       attribut	
                |       constructeur  
                |       methode     
		;

constructeur    :       nom
                        l_paraFormel
                        ev_l_exc bloc
                ;

methode		:	type ev_indices
			nom
			l_paraFormel 
			ev_l_exc bloc
                |       type ev_indices
			nom
			l_paraFormel 
			ev_l_exc ';'
		;

l_paraFormel	:	'(' ev_l_formel ')'
		;

ev_l_formel	:	
		|	l_formel
		;

l_formel	:	type ev_indices nom ev_indices
		|	l_formel ',' type ev_indices nom ev_indices
		;

ev_l_exc	:
		|	THROWS l_exc
		;

l_exc		:	exc
		|	l_exc ',' exc
		;

bloc		:	'{' ev_l_instr '}'
		;

ev_l_instr	:
		|	l_instr
		;

l_instr		:	instr
		|	l_instr instr
		;

instr		:	';'
                |       attribut
                |       VARIABLEpmi EQ formuleAri ';'
                |	WHILE '(' formuleLog ')' bloc
                |       DO bloc WHILE '(' formuleLog  ')' ';'
                |       RETURN formuleAri ';'
                |	trycatch
		;

attribut        :       type ev_indices nom ev_indices ';'
                |       type ev_indices nom  ev_indices EQ formuleAri ';'
                ;

ev_ste_if	:	
		|	ELSE bloc
		;

trycatch	:	TRY bloc
			l_catch
			ev_finally
		;

l_catch		:	catch
		|	l_catch catch
		;

catch		:	CATCH '(' type VARIABLE ')' bloc
		;

ev_finally	:
		|	FINALLY bloc
		;


%%
